## zlib 1.2.7.dfsg-13maemo1+0cssu1

=== debian/changelog ===
zlib (1:1.2.7.dfsg-13maemo1+0cssu1) unstable; urgency=low

  * Adopt package for Maemo
  * Requires fixed libxml2
  * ARM NEON patches
    - adler32 - from meego zlib-1.2.7-adler32_vec_kaffeemonster.patch
      (aprox. 7% decompression speed up)
    - slhash - from https://github.com/kaffeemonster/zlib/tree/slhash
      (approx 18% compression speed up)

 -- Ludek Finstrle <luf@pzkagis.cz>  Fri, 29 Dec 2012 19:50:51 +0100

zlib (1:1.2.3-9.osso9+0m5) unstable; urgency=low

  * This entry has been added by BIFH queue processor
    Suffix +0m5 added to package revision

 -- Attiq Malik <ext-attiq.1.malik@nokia.com>  Wed, 01 Jul 2009 13:16:21 +0300

zlib (1:1.2.3-9.osso9) unstable; urgency=low

  * Recompile. Fixes: NB#124322.

 -- Alexander Shishkin <ext-alexander.shishkin@nokia.com>  Mon, 29 Jun 2009 19:05:59 +0300

=== debian/control ===
Source: zlib
Section: libs
Priority: optional
Maintainer: Ludek Finstrle <luf@pzkagis.cz>
XSBC-Original-Maintainer: Mark Brown <broonie@debian.org>
Standards-Version: 3.6.2
Build-Depends: debhelper (>= 5)

Package: zlib1g
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Priority: required
Conflicts: zlib1 (<= 1:1.0.4-7), zlib1g-udeb, libxml2 (<< 2.6.32.dfsg-5maemo4+0m5+0cssu1)
Replaces: zlib1g-udeb
Provides: libz1
Description: compression library - runtime
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes the shared library.

Package: zlib1g-dbg
Architecture: any
Depends: zlib1g (= ${Source-Version})
Description: compression library - debug symbols
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes the shared library.

Package: zlib1g-dev
Section: libdevel
Architecture: any
Depends: zlib1g (= ${Source-Version}), libc6-dev | libc-dev, ${misc:Depends}
Conflicts: zlib1-dev
Provides: libz-dev
Description: compression library - development
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes the development support
 files.

Package: zlib-bin
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: compression library - sample programs
 Some generally useful sample programs from the contrib directory.
 Includes a "mini" implementation of `zip' and `unzip' called
 `minizip' and `miniunzip' respectively.

Package: zlib1g-udeb
XC-Package-Type: udeb
Architecture: any
Priority: optional
Conflicts: libxml2 (<< 2.6.32.dfsg-5maemo4+0m5+0cssu1)
Provides: zlib1g
Section: debian-installer
Description: compression library - runtime for Debian installer
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This minimal package includes the shared library
 for use with the Debian installer.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/quilt/quilt.make

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

VERSION:=$(shell LC_ALL=C dpkg-parsechangelog | grep '^Version:' | \
		 sed -e 's/^Version: *//' -e 's/-.*$$//' -e 's/^.*://')
SONAME=1

DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_ARCH       ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS    ?= $(shell dpkg-architecture -qDEB_HOST_GNU_OS)

CFLAGS = -Wall -g -D_REENTRANT

ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
TESTS=test
AR=ar
CC=gcc
CC32=gcc -m32
CC64=gcc -m64
else
AR=$(DEB_HOST_GNU_TYPE)-ar
CC=$(DEB_HOST_GNU_TYPE)-gcc
CC32=$(DEB_HOST_GNU_TYPE)-gcc -m32
CC64=$(DEB_HOST_GNU_TYPE)-gcc -m64
endif

# Did the user want to turn optimisation off for some reason?
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
CFLAGS=-O0
else
# By default, optimise for osso
CFLAGS=-O2

endif

# Use neon and soft-float mode on arm.
ifeq ($(DEB_BUILD_ARCH), armel)
	CFLAGS += -mfpu=neon -mfloat-abi=softfp -mtune=cortex-a8 -mcpu=cortex-a8

# Use thumb mode if it enabled.
ifneq (,$(findstring thumb,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -mthumb
endif
endif

UNALIGNED_ARCHS=i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386 lpia
ifneq (,$(findstring $(DEB_HOST_ARCH), $(UNALIGNED_ARCHS)))
CFLAGS+=-DUNALIGNED_OK
endif

COPYLIST=*.h *.c *.in zlib.map configure zlib.3 test

configure-stamp: configure
	dh_testdir

	if [ ! -f Makefile.stash ]; then cp Makefile Makefile.stash ; fi

	AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc" CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" uname=GNU ./configure --shared --prefix=/usr --libdir=\$${prefix}/lib

	touch $@

configure64-stamp: configure
	dh_testdir

	mkdir -p debian/64
	cp -r $(COPYLIST) debian/64
	cd debian/64 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(m64)" \
	    CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	    uname=GNU ./configure --shared --prefix=/usr  --libdir=\$${prefix}/usr/lib64
	touch $@

configure32-stamp: configure
	dh_testdir

	mkdir -p debian/32
	cp -r $(COPYLIST) debian/32
	cd debian/32 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(m32)" \
	    CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	    uname=GNU ./configure --shared --prefix=/usr --libdir=\$${prefix}/usr/lib32
	touch $@

configuren32-stamp: configure
	dh_testdir

	mkdir -p debian/n32
	cp -r $(COPYLIST) debian/n32
	cd debian/n32 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(mn32)" \
	    CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	    uname=GNU ./configure --shared --prefix=/usr --libdir=\$${prefix}/usr/lib32
	touch $@

build: patch build-stamp $(EXTRA_BUILD)
build-stamp: configure-stamp
	dh_testdir

	$(MAKE)
	$(MAKE) CC=$(DEB_HOST_GNU_TYPE)-gcc CFLAGS="-I../.. $(CFLAGS)" LDFLAGS="$(LDFLAGS)" -C contrib/minizip
	-$(MAKE) test

	touch $@

build64-stamp: configure64-stamp
	dh_testdir
	make -C debian/64
	touch $@


build32-stamp: configure32-stamp
	dh_testdir
	make -C debian/32
	touch $@

buildn32-stamp: configuren32-stamp
	dh_testdir
	make -C debian/n32
	touch $@

clean: unpatch
	dh_testdir
	dh_testroot

	$(MAKE) -C contrib/minizip clean
	$(MAKE) distclean

	rm -f build-stamp configure-stamp foo.gz
	rm -rf debian/64 build64-stamp configure64-stamp
	rm -rf debian/32 build32-stamp configure32-stamp
	rm -rf debian/n32 buildn32-stamp configuren32-stamp
	 -mv Makefile.stash Makefile
	  -mv zlibdefs.h.stash zlibdefs.h

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
	dh_link

	$(MAKE) prefix=$(CURDIR)/debian/tmp/usr install

	#install -d debian/tmp/lib
	#mv debian/tmp/usr/lib/libz.so.* debian/tmp/lib/
	#ln -sf /lib/$$(readlink debian/tmp/usr/lib/libz.so) debian/tmp/usr/lib/libz.so

install64: install build64-stamp
	$(MAKE) -C debian/64 prefix=$(CURDIR)/debian/tmp install

install32: install build32-stamp
	$(MAKE) -C debian/32 prefix=$(CURDIR)/debian/tmp install

installn32: install buildn32-stamp
	$(MAKE) -C debian/n32 prefix=$(CURDIR)/debian/tmp install
	
# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install $(EXTRA_INSTALL)
	dh_testdir
	dh_testroot
	dh_installchangelogs -s ChangeLog
	dh_installdocs -s
	dh_installexamples -s
	mkdir -p debian/tmp/usr/bin
	cp contrib/minizip/minizip debian/tmp/usr/bin
	cp contrib/minizip/miniunz debian/tmp/usr/bin/miniunzip
	dh_install -s --sourcedir=debian/tmp
	dh_installman -s
#	dh_lintian -s #no lintian in debhelper 5
	dh_link -s
	dh_strip -s --dbg-package=zlib1g-dbg
	dh_compress -s
	dh_fixperms -s
	dh_makeshlibs -pzlib1g -V"zlib1g (>= 1:1.2.1)" --add-udeb=zlib1g-udeb
	dh_installdeb -s
	dh_shlibdeps -s
	dh_gencontrol -s
	dh_md5sums -s
	dh_builddeb -s

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install install64 install32

## zlib 1.2.8.dfsg

=== debian/changelog ===
zlib (1:1.2.8.dfsg-2ubuntu4.3) xenial-security; urgency=medium

  * SECURITY UPDATE: improper pointer arithmetic might allow
    context-dependent attackers to have unspecified impact
    - debian/patches/CVE-2016-9840.patch: remove offset pointer optimization
      in inftrees.c
    - CVE-2016-9840
  * SECURITY UPDATE: improper pointer arithmetic might allow
    context-dependent attackers to have unspecified impact
    - debian/patches/CVE-2016-9841.patch: use post-increment only in inffast.c
    - CVE-2016-9841
  * SECURITY UPDATE: vectors involving left shifts of negative integers might
    allow context-dependent attackers to have unspecified impact
    - debian/patches/CVE-2016-9842_1.patch: avoid shifts of negative values in
      inflateMark()
    - debian/patches/CVE-2016-9842_2.patch: avoid casting an out-of-range
      value to long
    - CVE-2016-9842
  * SECURITY UPDATE: vectors involving big-endian CRC calculation might allow
    context-dependent attackers to have unspecified impact
    - debian/patches/CVE-2016-9843.patch: avoid pre-decrement of pointer in 
      big-endian CRC calculation
    - CVE-2016-9843

 -- Avital Ostromich <avital.ostromich@canonical.com>  Wed, 08 Jan 2020 11:06:35 -0500

zlib (1:1.2.8.dfsg-2ubuntu4.1) xenial-proposed; urgency=medium

  * SRU
  * Move zconf.h back to /usr/include (not differing across architectures)
    anymore. Closes: #787956. LP: #1512992.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 03 Mar 2017 18:31:53 +0100

zlib (1:1.2.8.dfsg-2ubuntu4) wily; urgency=medium

  * Call dh_makeshlibs for the 64bit multilib package.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 13 Sep 2015 17:47:16 +0200

zlib (1:1.2.8.dfsg-2ubuntu3) wily; urgency=medium

  * Install zconf.h for multilib packages.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 13 Sep 2015 16:26:09 +0200

zlib (1:1.2.8.dfsg-2ubuntu1) vivid; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Build x32 packages.  

 -- Michael Vogt <michael.vogt@ubuntu.com>  Mon, 27 Oct 2014 10:16:38 +0100

zlib (1:1.2.8.dfsg-2) unstable; urgency=low

  * Drop zlib-bin package as minizip has now been packaged separately,
    delay due to lack of notice regarding upload (closes: #753070).

 -- Mark Brown <broonie@debian.org>  Sat, 16 Aug 2014 15:12:11 +0100

zlib (1:1.2.8.dfsg-1ubuntu1) saucy; urgency=low

  * Resynchronise with Debian.  Remaining changes:
    - Build x32 packages.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 13 May 2013 13:31:17 +0100

zlib (1:1.2.8.dfsg-1) unstable; urgency=low

  * New upstream release.
  * Policy 3.9.4.
  * Tweak version for gzseek64 and gztell64 (closes: #687076).
  * Install zconf.h in multiarch path (closes: #698648).

 -- Mark Brown <broonie@debian.org>  Fri, 03 May 2013 16:30:36 +0100

=== debian/control ===
Source: zlib
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Mark Brown <broonie@debian.org>
Standards-Version: 3.9.4
Homepage: http://zlib.net/
Build-Depends: debhelper (>= 8.1.3~), binutils (>= 2.18.1~cvs20080103-2) [mips mipsel], gcc-multilib [amd64 i386 kfreebsd-amd64 mips mipsel powerpc ppc64 s390 sparc s390x], dpkg-dev (>= 1.16.1)

Package: zlib1g
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Priority: required
Conflicts: zlib1 (<= 1:1.0.4-7)
Breaks: libxml2 (<< 2.7.6.dfsg-2), texlive-binaries (<< 2009-12)
Provides: libz1
Description: compression library - runtime
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes the shared library.

Package: zlib1g-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: zlib1g (= ${binary:Version}), libc6-dev | libc-dev, ${misc:Depends}
Conflicts: zlib1-dev
Provides: libz-dev
Description: compression library - development
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes the development support
 files.

Package: zlib1g-dbg
Section: debug
Priority: extra
Architecture: any
Depends: zlib1g (= ${binary:Version})
Provides: libz-dbg
Description: compression library - development
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes debugging symbols for use
 when debugging applications which use zlib.

Package: zlib1g-udeb
XC-Package-Type: udeb
Architecture: any
Priority: optional
Section: debian-installer
Description: compression library - runtime for Debian installer
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This minimal package includes the shared library
 for use with the Debian installer.

Package: lib64z1
Architecture: sparc s390 i386 powerpc mips mipsel
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: amd64-libs (<< 1.4)
Description: compression library - 64 bit runtime
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes a 64 bit version of the
 shared library.

Package: lib64z1-dev
Section: libdevel
Architecture: sparc s390 i386 powerpc mips mipsel
Depends: lib64z1 (= ${binary:Version}), zlib1g-dev (= ${binary:Version}), lib64c-dev, ${misc:Depends}
Replaces: amd64-libs-dev (<< 1.4)
Provides: lib64z-dev
Description: compression library - 64 bit development
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes the development support
 files for building 64 bit applications.

Package: lib32z1
Architecture: amd64 ppc64 kfreebsd-amd64 s390x
Conflicts: libc6-i386 (<= 2.9-18)
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: ia32-libs (<< 1.5)
Description: compression library - 32 bit runtime
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes a 32 bit version of the
 shared library.

Package: lib32z1-dev
Section: libdevel
Architecture: amd64 ppc64 kfreebsd-amd64 s390x
Conflicts: libc6-i386 (<= 2.9-18)
Depends: lib32z1 (= ${binary:Version}), zlib1g-dev (= ${binary:Version}), lib32c-dev, ${misc:Depends}
Provides: lib32z-dev
Replaces: ia32-libs-dev (<< 1.5)
Description: compression library - 32 bit development
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes the development support
 files for building 32 bit applications.

Package: libn32z1
Architecture: mips mipsel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: compression library - n32 runtime
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes a n32 version of the shared
 library.

Package: libn32z1-dev
Section: libdevel
Architecture: mips mipsel
Depends: libn32z1 (= ${binary:Version}), zlib1g-dev (= ${binary:Version}), libn32c-dev, ${misc:Depends}
Provides: libn32z-dev
Description: compression library - n32 development
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes the development support
 files for building n32 applications.

Package: libx32z1
Architecture: amd64 i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: compression library - x32 runtime
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes a n32 version of the shared
 library.

Package: libx32z1-dev
Section: libdevel
Architecture: amd64 i386
Depends: libx32z1 (= ${binary:Version}), zlib1g-dev (= ${binary:Version}), libc6-dev-x32, ${misc:Depends}
Provides: libx32z-dev
Description: compression library - x32 development
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes the development support
 files for building n32 applications.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_ARCH       ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS    ?= $(shell dpkg-architecture -qDEB_HOST_GNU_OS)
DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CFLAGS = `dpkg-buildflags --get CFLAGS` `dpkg-buildflags --get CPPFLAGS` -Wall -D_REENTRANT
LDFLAGS = `dpkg-buildflags --get LDFLAGS`

# binutils doesn't supply the prefixed version normally like GCC does so
# we can't just unconditionally use DEB_HOST_GNU_TYPE-ar
ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
	AR=ar
else
	AR=$(DEB_HOST_GNU_TYPE)-ar
endif

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O3
endif

32-ARCHS=amd64 ppc64 kfreebsd-amd64 s390x
64-ARCHS=s390 sparc i386 powerpc mips mipsel

ifneq (,$(findstring $(DEB_HOST_ARCH), $(32-ARCHS)))
EXTRA_INSTALL=install32
EXTRA_BUILD=build32-stamp
# s390x fails at compatibility.
ifneq (,$(findstring $(DEB_HOST_ARCH), s390x))
m32=-m31
else
m32=-m32
endif
endif

ifneq (,$(findstring s390x, $(DEB_HOST_ARCH)))
else
ifneq (,$(findstring $(DEB_HOST_ARCH), $(64-ARCHS)))
EXTRA_INSTALL=install64
EXTRA_BUILD=build64-stamp
# MIPS doesn't use -m64
ifneq (,$(findstring $(DEB_HOST_ARCH), mips mipsel))
m64=-mabi=64
else
m64=-m64
endif
endif
endif

N32-ARCHS=mips mipsel
ifneq (,$(findstring $(DEB_HOST_ARCH), $(N32-ARCHS)))
EXTRA_INSTALL+=installn32
EXTRA_BUILD+=buildn32-stamp
mn32=-mabi=n32
endif

X32-ARCHS=amd64 i386
ifneq (,$(findstring $(DEB_HOST_ARCH), $(X32-ARCHS)))
EXTRA_INSTALL+=installx32
EXTRA_BUILD+=buildx32-stamp
mx32=-mx32
endif

UNALIGNED_ARCHS=i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386 lpia
ifneq (,$(findstring $(DEB_HOST_ARCH), $(UNALIGNED_ARCHS)))
CFLAGS+=-DUNALIGNED_OK
endif

COPYLIST=*.h *.c *.in zlib.map configure zlib.3 test

configure-stamp: configure
	dh_testdir

	if [ ! -f Makefile.stash ]; then cp Makefile Makefile.stash ; fi

	AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc" CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" uname=GNU ./configure --shared --prefix=/usr --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)

	touch $@

configure64-stamp: configure
	dh_testdir

	mkdir -p debian/64
	cp -r $(COPYLIST) debian/64
	cd debian/64 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(m64)" \
	    CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	    uname=GNU ./configure --shared --prefix=/usr  --libdir=\$${prefix}/usr/lib64
	touch $@

configure32-stamp: configure
	dh_testdir

	mkdir -p debian/32
	cp -r $(COPYLIST) debian/32
	cd debian/32 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(m32)" \
	    CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	    uname=GNU ./configure --shared --prefix=/usr --libdir=\$${prefix}/usr/lib32
	touch $@

configuren32-stamp: configure
	dh_testdir

	mkdir -p debian/n32
	cp -r $(COPYLIST) debian/n32
	cd debian/n32 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(mn32)" \
	    CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	    uname=GNU ./configure --shared --prefix=/usr --libdir=\$${prefix}/usr/lib32
	touch $@

configurex32-stamp: configure
	dh_testdir

	mkdir -p debian/x32
	cp -r $(COPYLIST) debian/x32
	cd debian/x32 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(mx32)" \
	    CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	    uname=GNU ./configure --shared --prefix=/usr --libdir=\$${prefix}/usr/libx32
	touch $@

build: build-stamp $(EXTRA_BUILD)
build-stamp: configure-stamp
	dh_testdir

	$(MAKE)
	-$(MAKE) test

	touch $@

build64-stamp: configure64-stamp
	dh_testdir
	make -C debian/64
	touch $@

build32-stamp: configure32-stamp
	dh_testdir
	make -C debian/32
	touch $@

buildn32-stamp: configuren32-stamp
	dh_testdir
	make -C debian/n32
	touch $@

buildx32-stamp: configurex32-stamp
	dh_testdir
	make -C debian/x32
	touch $@

clean:
	dh_testdir
	dh_testroot

	$(MAKE) distclean

	rm -f build-stamp configure-stamp foo.gz 
	rm -rf debian/64 build64-stamp configure64-stamp
	rm -rf debian/32 build32-stamp configure32-stamp
	rm -rf debian/n32 buildn32-stamp configuren32-stamp
	rm -rf debian/x32 buildx32-stamp configurex32-stamp
	-mv Makefile.stash Makefile
	-mv zlibdefs.h.stash zlibdefs.h

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	$(MAKE) prefix=$(CURDIR)/debian/tmp/usr install

	install -d debian/tmp/lib/$(DEB_HOST_MULTIARCH)
	mv debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libz.so.* debian/tmp/lib/$(DEB_HOST_MULTIARCH)
	ln -sf /lib/$(DEB_HOST_MULTIARCH)/$$(readlink debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libz.so) debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libz.so

install64: install build64-stamp
	$(MAKE) -C debian/64 prefix=$(CURDIR)/debian/tmp install

install32: install build32-stamp
	$(MAKE) -C debian/32 prefix=$(CURDIR)/debian/tmp install

installn32: install buildn32-stamp
	$(MAKE) -C debian/n32 prefix=$(CURDIR)/debian/tmp install

installx32: install buildx32-stamp
	$(MAKE) -C debian/x32 prefix=$(CURDIR)/debian/tmp install

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install $(EXTRA_INSTALL)
	dh_testdir
	dh_testroot
	dh_installchangelogs -s ChangeLog
	dh_installdocs -s
	dh_installexamples -s
	dh_install -s --sourcedir=debian/tmp
ifneq (,$(m32))
  ifeq ($(DEB_HOST_ARCH),amd64)
	mkdir -p debian/lib32z1-dev/usr/include/i386-linux-gnu
	cp debian/32/zconf.h debian/lib32z1-dev/usr/include/i386-linux-gnu/.
  else ifeq ($(DEB_HOST_ARCH),ppc64)
	mkdir -p debian/lib32z1-dev/usr/include/powerpc-linux-gnu
	cp debian/32/zconf.h debian/lib32z1-dev/usr/include/powerpc-linux-gnu/.
  else ifeq ($(DEB_HOST_ARCH),s390x)
	mkdir -p debian/lib32z1-dev/usr/include/s390-linux-gnu
	cp debian/32/zconf.h debian/lib32z1-dev/usr/include/s390-linux-gnu/.
  endif
endif
ifneq (,$(m64))
  ifeq ($(DEB_HOST_ARCH),i386)
	mkdir -p debian/lib64z1-dev/usr/include/x86_64-linux-gnu
	cp debian/64/zconf.h debian/lib64z1-dev/usr/include/x86_64-linux-gnu/.
  else ifeq ($(DEB_HOST_ARCH),powerpc)
	mkdir -p debian/lib64z1-dev/usr/include/powerpc64-linux-gnu
	cp debian/64/zconf.h debian/lib64z1-dev/usr/include/powerpc64-linux-gnu/.
  else ifeq ($(DEB_HOST_ARCH),s390)
	mkdir -p debian/lib64z1-dev/usr/include/s390x-linux-gnu
	cp debian/64/zconf.h debian/lib64z1-dev/usr/include/s390x-linux-gnu/.
  endif
endif
ifneq (,$(mx32))
	mkdir -p debian/libx32z1-dev/usr/include/x86_64-linux-gnux32
	cp debian/x32/zconf.h debian/libx32z1-dev/usr/include/x86_64-linux-gnux32/.
endif
	dh_installman -s
	dh_lintian -s
	dh_link -s
	dh_strip -s --dbg-package=zlib1g-dbg
	dh_compress -s
	dh_fixperms -s
	dh_makeshlibs -pzlib1g -V"zlib1g (>= 1:1.2.3.3.dfsg-1)" --add-udeb=zlib1g-udeb
ifneq (,$(findstring $(DEB_HOST_ARCH), $(32-ARCHS)))
	dh_makeshlibs -plib32z1 -V"lib32z1 (>= 1:1.2.3.3.dfsg-1)"
endif
ifneq (,$(findstring $(DEB_HOST_ARCH), $(64-ARCHS)))
	dh_makeshlibs -plib64z1 -V"lib64z1 (>= 1:1.2.3.3.dfsg-1)"
endif
ifneq (,$(findstring $(DEB_HOST_ARCH), $(N32-ARCHS)))
	dh_makeshlibs -plibn32z1 -V"libn32z1 (>= 1:1.2.3.3.dfsg-1)"
endif
ifneq (,$(findstring $(DEB_HOST_ARCH), $(X32-ARCHS)))
	dh_makeshlibs -plibx32z1 -V"libx32z1 (>= 1:1.2.3.3.dfsg-1)"
endif
	dh_installdeb -s
	dh_shlibdeps -s
	dh_gencontrol -s
	dh_md5sums -s
	dh_builddeb -s

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install install64 install32

## zlib 1.2.11.dfsg

=== debian/changelog ===
zlib (1:1.2.11.dfsg-4.1ubuntu1) kinetic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Build x32 packages
    - debian/zlib-core.symbols: Drop dfsg suffix from version
    - Add watch file, with GPG tarball checking, and version mangling
    - Cherry-pick Permit-a-deflateParams-parameter-change-asap.patch:
    - Cherrypick PR#410 to enable hardware-accelerated deflate.
    - Copmile with DFLTCC enabled on s390x.
    - Improve crc32 performance on P8, proposed upstream patch.
    - Enable hardware compression on s390x at level 6.
    - Cherrypick update of s390x hw acceleration #410 pull request patch,
      which corrects inflateSyncPoint() return value to always gracefully
      fail when hw acceleration is in use.
    - d/rules: use configure options for dfltcc instead of hardcoding
       the CFLAGS
    - d/p/lp1932010-ibm-z-add-vectorized-crc32-implementation.patch
      ported from zlib-ng #912, adding a vectorized implementation
      of CRC32 on s390x architectures based on kernel code.
    - d/p/lp1932010-ibm-z-add-vectorized-crc32-implementation.patch: adjust
      to not make a PLT call in an ifunc on s390/s390x.
    - debian/patches/CVE-2018-25032-2.patch: assure that the number of bits
      for deflatePrime() is valid in deflate.c.
    - d/p/410-lp1961427.patch ported from zlib #410, fixing
      compressBound() with hw acceleration.
  * Dropped changes, included in Debian:
    - debian/patches/CVE-2018-25032-1.patch: fix a bug that can crash
      deflate on some input when using Z_FIXED in deflate.c, deflate.h.
  * Refresh 410.patch for upstream changes.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 18 Aug 2022 09:09:22 -0700

zlib (1:1.2.11.dfsg-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix a bug when getting a gzip header extra field with inflate()
    (CVE-2022-37434) (Closes: #1016710)
  * Fix extra field processing bug that dereferences NULL state->head

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 12 Aug 2022 22:15:03 +0200

zlib (1:1.2.11.dfsg-4) unstable; urgency=medium

  * Pick upstream patch for CVE-2018-25032 (closes: #1008265).

 -- Mark Brown <broonie@debian.org>  Fri, 25 Mar 2022 23:32:05 +0000

zlib (1:1.2.11.dfsg-3) unstable; urgency=low

  * Add build-arch and build-indep (#999292).
  * Bump debhelper requirement to current.
  * Add win32 to the list of files excluded from the DFSG
    tarball (closes: #919598).
  * Tighten matching for 32 bit architectures using patch from
    Helmut Grohne (closes: #1006799).
  * Policy 4.0.0 (no changes).

 -- Mark Brown <broonie@debian.org>  Fri, 18 Mar 2022 00:21:37 +0000

zlib (1:1.2.11.dfsg-2ubuntu10) kinetic; urgency=medium

  * d/p/410-lp1961427.patch ported from zlib #410, fixing
    compressBound() with hw acceleration. LP: #1961427
    Thanks to Ilya Leoshkevich <iii@linux.ibm.com>.
    In addition a patch is needed for bedtools.

 -- Frank Heimes <frank.heimes@canonical.com>  Thu, 21 Jul 2022 09:30:05 +0100

zlib (1:1.2.11.dfsg-2ubuntu9) jammy; urgency=medium

  * SECURITY UPDATE: memory corruption when deflating
    - debian/patches/CVE-2018-25032-1.patch: fix a bug that can crash
      deflate on some input when using Z_FIXED in deflate.c, deflate.h.
    - debian/patches/CVE-2018-25032-2.patch: assure that the number of bits
      for deflatePrime() is valid in deflate.c.
    - CVE-2018-25032

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 25 Mar 2022 08:06:31 -0400

zlib (1:1.2.11.dfsg-2ubuntu7) impish; urgency=medium

  [ Simon Chopin ]
  * d/rules: use configure options for dfltcc instead of hardcoding
    the CFLAGS
  * d/p/lp1932010-ibm-z-add-vectorized-crc32-implementation.patch
    ported from zlib-ng #912, adding a vectorized implementation
    of CRC32 on s390x architectures based on kernel code. LP: #1932010

  [ Michael Hudson-Doyle ]
  * d/p/lp1932010-ibm-z-add-vectorized-crc32-implementation.patch: adjust to
    not make a PLT call in an ifunc on s390/s390x. 

 -- Simon Chopin <simon.chopin@canonical.com>  Thu, 12 Aug 2021 15:45:49 +1200

zlib (1:1.2.11.dfsg-2ubuntu6) hirsute; urgency=medium

  * No-change rebuild to build with lto.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 28 Mar 2021 09:10:07 +0200

zlib (1:1.2.11.dfsg-2ubuntu5) hirsute; urgency=medium

  * No-change rebuild to drop the udeb package.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 22 Feb 2021 10:36:58 +0100

zlib (1:1.2.11.dfsg-2ubuntu4) groovy; urgency=medium

  * Cherrypick update of s390x hw acceleration #410 pull request patch,
    which corrects inflateSyncPoint() return value to always gracefully
    fail when hw acceleration is in use. This fixes rsync failure with
    zlib compression on hw accelerated s390x. LP: #1899621

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 15 Oct 2020 11:01:38 +0100

zlib (1:1.2.11.dfsg-2ubuntu3) groovy; urgency=medium

  * Enable hardware compression on s390x at level 6. LP: #1884514

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 24 Sep 2020 08:44:35 +1200

zlib (1:1.2.11.dfsg-2ubuntu2) groovy; urgency=medium

  * Update d/patches/410.patch to current state. LP: #1882494, #1889059, #1893170

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 20 Aug 2020 11:52:59 +1200

zlib (1:1.2.11.dfsg-2ubuntu1) focal; urgency=medium

  * Merge with Debian; remaining changes:
    - Build x32 packages
    - debian/zlib-core.symbols: Drop dfsg suffix from version
    - Add watch file, with GPG tarball checking, and version mangling
    - Drop unused patches
    - Cherry-pick Permit-a-deflateParams-parameter-change-asap.patch:
      (LP: #1692870)
    - Cherrypick PR#410 to enable hardware-accelerated deflate.
    - Copmile with DFLTCC enabled on s390x. LP: #1823157
    - Improve crc32 performance on P8, proposed upstream patch. LP: #1742941.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 25 Feb 2020 16:59:52 +0100

zlib (1:1.2.11.dfsg-2) unstable; urgency=low

  * Acknowledge previous NMUs (closes: #949388).


=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Mark Brown <broonie@debian.org>
-Standards-Version: 3.9.4
+Standards-Version: 4.0.0
 Homepage: http://zlib.net/
-Build-Depends: debhelper (>= 8.1.3~), binutils (>= 2.18.1~cvs20080103-2) [mips mipsel], gcc-multilib [amd64 i386 kfreebsd-amd64 mips mipsel powerpc ppc64 s390 sparc s390x], dpkg-dev (>= 1.16.1)
+Build-Depends: debhelper (>= 8.1.3~), gcc-multilib [amd64 i386 kfreebsd-amd64 mips mipsel powerpc ppc64 s390 sparc s390x mipsn32 mipsn32el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64 mips64el mips64r6 mips64r6el x32] <!nobiarch>, dpkg-dev (>= 1.16.1)
 
 Package: zlib1g
 Architecture: any
@@ -32,17 +32,6 @@
  in gzip and PKZIP.  This package includes the development support
  files.
 
-Package: zlib1g-dbg
-Section: debug
-Priority: extra
-Architecture: any
-Depends: zlib1g (= ${binary:Version})
-Provides: libz-dbg
-Description: compression library - development
- zlib is a library implementing the deflate compression method found
- in gzip and PKZIP.  This package includes debugging symbols for use
- when debugging applications which use zlib.
-
 Package: zlib1g-udeb
 XC-Package-Type: udeb
 Architecture: any
@@ -54,7 +43,8 @@
  for use with the Debian installer.
 
 Package: lib64z1
-Architecture: sparc s390 i386 powerpc mips mipsel
+Architecture: sparc s390 i386 powerpc mips mipsel mipsn32 mipsn32el mipsr6 mipsr6el mipsn32r6 mipsn32r6el x32
+Build-Profiles: <!nobiarch>
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Replaces: amd64-libs (<< 1.4)
 Description: compression library - 64 bit runtime
@@ -64,17 +54,23 @@
 
 Package: lib64z1-dev
 Section: libdevel
-Architecture: sparc s390 i386 powerpc mips mipsel
+Architecture: sparc s390 i386 powerpc mips mipsel mipsn32 mipsn32el mipsr6 mipsr6el mipsn32r6 mipsn32r6el x32
+Build-Profiles: <!nobiarch>
 Depends: lib64z1 (= ${binary:Version}), zlib1g-dev (= ${binary:Version}), lib64c-dev, ${misc:Depends}
 Replaces: amd64-libs-dev (<< 1.4)
 Provides: lib64z-dev
-Description: compression library - 64 bit development
+Description: compression library - 64 bit - DO NOT USE EXCEPT FOR PACKAGING
  zlib is a library implementing the deflate compression method found
  in gzip and PKZIP.  This package includes the development support
  files for building 64 bit applications.
+ .
+ This package should ONLY be used for building packages, users who do
+ not need to build packages should use multiarch to install the relevant
+ runtime.
 
 Package: lib32z1
 Architecture: amd64 ppc64 kfreebsd-amd64 s390x
+Build-Profiles: <!nobiarch>
 Conflicts: libc6-i386 (<= 2.9-18)
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Replaces: ia32-libs (<< 1.5)
@@ -86,17 +82,23 @@
 Package: lib32z1-dev
 Section: libdevel
 Architecture: amd64 ppc64 kfreebsd-amd64 s390x
+Build-Profiles: <!nobiarch>
 Conflicts: libc6-i386 (<= 2.9-18)
 Depends: lib32z1 (= ${binary:Version}), zlib1g-dev (= ${binary:Version}), lib32c-dev, ${misc:Depends}
 Provides: lib32z-dev
 Replaces: ia32-libs-dev (<< 1.5)
-Description: compression library - 32 bit development
+Description: compression library - 32 bit - DO NOT USE EXCEPT FOR PACKAGING
  zlib is a library implementing the deflate compression method found
  in gzip and PKZIP.  This package includes the development support
  files for building 32 bit applications.
+ .
+ This package should ONLY be used for building packages, users who do
+ not need to build packages should use multiarch to install the relevant
+ runtime.
 
 Package: libn32z1
 Architecture: mips mipsel
+Build-Profiles: <!nobiarch>
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: compression library - n32 runtime
  zlib is a library implementing the deflate compression method found
@@ -106,12 +108,17 @@
 Package: libn32z1-dev
 Section: libdevel
 Architecture: mips mipsel
+Build-Profiles: <!nobiarch>
 Depends: libn32z1 (= ${binary:Version}), zlib1g-dev (= ${binary:Version}), libn32c-dev, ${misc:Depends}
 Provides: libn32z-dev
-Description: compression library - n32 development
+Description: compression library - n32 - DO NOT USE EXCEPT FOR PACKAGING
  zlib is a library implementing the deflate compression method found
  in gzip and PKZIP.  This package includes the development support
  files for building n32 applications.
+ .
+ This package should ONLY be used for building packages, users who do
+ not need to build packages should use multiarch to install the relevant
+ runtime.
 
 Package: libx32z1
 Architecture: amd64 i386
@@ -126,7 +133,11 @@
 Architecture: amd64 i386
 Depends: libx32z1 (= ${binary:Version}), zlib1g-dev (= ${binary:Version}), libc6-dev-x32, ${misc:Depends}
 Provides: libx32z-dev
-Description: compression library - x32 development
+Description: compression library - x32 - DO NOT USE EXCEPT FOR PACKAGING
  zlib is a library implementing the deflate compression method found
  in gzip and PKZIP.  This package includes the development support
  files for building n32 applications.
+ .
+ This package should ONLY be used for building packages, users who do
+ not need to build packages should use multiarch to install the relevant
+ runtime.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_ARCH       ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS    ?= $(shell dpkg-architecture -qDEB_HOST_GNU_OS)
DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CFLAGS = `dpkg-buildflags --get CFLAGS` `dpkg-buildflags --get CPPFLAGS` -Wall -D_REENTRANT
LDFLAGS = `dpkg-buildflags --get LDFLAGS`
EXTRA_MAKE =

CONFIGURE_COMMON=--shared --prefix=/usr
CONFIGURE_HOST=--libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)

# binutils doesn't supply the prefixed version normally like GCC does so
# we can't just unconditionally use DEB_HOST_GNU_TYPE-ar
ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
	AR=ar
else
	AR=$(DEB_HOST_GNU_TYPE)-ar
endif

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O3
endif

ifeq (,$(filter nobiarch,$(DEB_BUILD_PROFILES)))

32-ARCHS=amd64 ppc64 kfreebsd-amd64 s390x
64-ARCHS=s390 sparc i386 powerpc mips mipsel mipsn32 mipsn32el mipsr6 mipsr6el mipsn32r6 mipsn32r6el x32

ifneq (,$(filter $(DEB_HOST_ARCH), $(32-ARCHS)))
EXTRA_INSTALL=install32
EXTRA_BUILD=build32-stamp
# s390x fails at compatibility.
ifneq (,$(filter $(DEB_HOST_ARCH), s390x))
m32=-m31
CFLAGS += -DDFLTCC_LEVEL_MASK=0x7e
CONFIGURE_COMMON += --dfltcc
CONFIGURE_HOST += --crc32-vx
else
m32=-m32
endif
endif

ifneq (,$(filter s390x, $(DEB_HOST_ARCH)))
else
ifneq (,$(filter $(DEB_HOST_ARCH), $(64-ARCHS)))
EXTRA_INSTALL=install64
EXTRA_BUILD=build64-stamp
# MIPS doesn't use -m64
ifneq (,$(filter $(DEB_HOST_ARCH), mips mipsel mipsn32 mipsn32el mipsr6 mipsr6el mipsn32r6 mipsn32r6el))
m64=-mabi=64
else
m64=-m64
endif
endif
endif

N32-ARCHS=mips mipsel
ifneq (,$(filter $(DEB_HOST_ARCH), $(N32-ARCHS)))
EXTRA_INSTALL+=installn32
EXTRA_BUILD+=buildn32-stamp
mn32=-mabi=n32
endif

endif # !nobiarch

X32-ARCHS=amd64 i386
ifneq (,$(findstring $(DEB_HOST_ARCH), $(X32-ARCHS)))
EXTRA_INSTALL+=installx32
EXTRA_BUILD+=buildx32-stamp
mx32=-mx32
endif

UNALIGNED_ARCHS=i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386 lpia
ifneq (,$(filter $(DEB_HOST_ARCH), $(UNALIGNED_ARCHS)))
CFLAGS+=-DUNALIGNED_OK
endif

COPYLIST=*.h *.c *.in zlib.map configure zlib.3 test contrib

configure-stamp: configure
	dh_testdir

	if [ ! -f Makefile.stash ]; then cp Makefile Makefile.stash ; fi

	AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc" CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" uname=GNU ./configure $(CONFIGURE_COMMON) $(CONFIGURE_HOST)

	touch $@

configure64-stamp: configure
	dh_testdir

	mkdir -p debian/64
	cp -r $(COPYLIST) debian/64
	cd debian/64 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(m64)" \
	    CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	    uname=GNU ./configure $(CONFIGURE_COMMON) --libdir=\$${prefix}/usr/lib64
	touch $@

configure32-stamp: configure
	dh_testdir

	mkdir -p debian/32
	cp -r $(COPYLIST) debian/32
	cd debian/32 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(m32)" \
	    CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	    uname=GNU ./configure $(CONFIGURE_COMMON) --libdir=\$${prefix}/usr/lib32
	touch $@

configuren32-stamp: configure
	dh_testdir

	mkdir -p debian/n32
	cp -r $(COPYLIST) debian/n32
	cd debian/n32 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(mn32)" \
	    CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	    uname=GNU ./configure $(CONFIGURE_COMMON) --libdir=\$${prefix}/usr/lib32
	touch $@

configurex32-stamp: configure
	dh_testdir

	mkdir -p debian/x32
	cp -r $(COPYLIST) debian/x32
	cd debian/x32 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(mx32)" \
	    CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	    uname=GNU ./configure $(CONFIGURE_COMMON) --libdir=\$${prefix}/usr/libx32
	touch $@

build: build-arch build-indep
build-indep:

build-arch: build-stamp $(EXTRA_BUILD)
build-stamp: configure-stamp
	dh_testdir

	$(MAKE) $(EXTRA_MAKE)
	-$(MAKE) test

	touch $@

build64-stamp: configure64-stamp
	dh_testdir
	make -C debian/64
	touch $@

build32-stamp: configure32-stamp
	dh_testdir
	make -C debian/32 $(EXTRA_MAKE)
	touch $@

buildn32-stamp: configuren32-stamp
	dh_testdir
	make -C debian/n32
	touch $@

buildx32-stamp: configurex32-stamp
	dh_testdir
	make -C debian/x32
	touch $@

clean:
	dh_testdir
	dh_testroot

	$(MAKE) distclean

	rm -f build-stamp configure-stamp foo.gz 
	rm -rf debian/64 build64-stamp configure64-stamp
	rm -rf debian/32 build32-stamp configure32-stamp
	rm -rf debian/n32 buildn32-stamp configuren32-stamp
	rm -rf debian/x32 buildx32-stamp configurex32-stamp
	-mv Makefile.stash Makefile
	-mv zlibdefs.h.stash zlibdefs.h

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	$(MAKE) prefix=$(CURDIR)/debian/tmp/usr install

	install -d debian/tmp/lib/$(DEB_HOST_MULTIARCH)
	mv debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libz.so.* debian/tmp/lib/$(DEB_HOST_MULTIARCH)
	ln -sf /lib/$(DEB_HOST_MULTIARCH)/$$(readlink debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libz.so) debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libz.so

install64: install build64-stamp
	$(MAKE) -C debian/64 prefix=$(CURDIR)/debian/tmp install

install32: install build32-stamp
	$(MAKE) -C debian/32 prefix=$(CURDIR)/debian/tmp install

installn32: install buildn32-stamp
	$(MAKE) -C debian/n32 prefix=$(CURDIR)/debian/tmp install

installx32: install buildx32-stamp
	$(MAKE) -C debian/x32 prefix=$(CURDIR)/debian/tmp install

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install $(EXTRA_INSTALL)
	dh_testdir
	dh_testroot
	dh_installchangelogs -a ChangeLog
	dh_installdocs -a
	dh_installexamples -a
	dh_install -a --sourcedir=debian/tmp
	dh_installman -a
	dh_lintian -a
	dh_link -a
	dh_strip -a --dbgsym-migration="zlib1g-dbg (<< 1:1.2.11.dfsg-2~)"
	dh_compress -a
	dh_fixperms -a
	dh_makeshlibs -pzlib1g -V"zlib1g (>= 1:1.2.3.3.dfsg-1)" --add-udeb=zlib1g-udeb
ifeq (,$(filter nobiarch,$(DEB_BUILD_PROFILES)))
ifneq (,$(filter $(DEB_HOST_ARCH), $(32-ARCHS)))
	dh_makeshlibs -plib32z1 -V"lib32z1 (>= 1:1.2.3.3.dfsg-1)"
endif
ifneq (,$(filter $(DEB_HOST_ARCH), $(64-ARCHS)))
	dh_makeshlibs -plib64z1 -V"lib64z1 (>= 1:1.2.3.3.dfsg-1)"
endif
ifneq (,$(filter $(DEB_HOST_ARCH), $(N32-ARCHS)))
	dh_makeshlibs -plibn32z1 -V"libn32z1 (>= 1:1.2.3.3.dfsg-1)"
endif
ifneq (,$(findstring $(DEB_HOST_ARCH), $(X32-ARCHS)))
	dh_makeshlibs -plibx32z1 -V"libx32z1 (>= 1:1.2.3.3.dfsg-1)"
endif
endif
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install install64 install32

## zlib 1.2.11.dfsg-2ubuntu9.2+11.0trisquel0

=== contrib/minizip/Makefile ===
CC=cc
CFLAGS+=-O -I../..
ZLIB=-L../.. -lz

UNZ_OBJS = miniunz.o unzip.o ioapi.o
ZIP_OBJS = minizip.o zip.o   ioapi.o

.c.o:
	$(CC) -c $(CFLAGS) $*.c

all: miniunz minizip

miniunz:  $(UNZ_OBJS)
	$(CC) $(CFLAGS) -o $@ $(UNZ_OBJS) $(ZLIB) $(LDFLAGS)

minizip:  $(ZIP_OBJS)
	$(CC) $(CFLAGS) -o $@ $(ZIP_OBJS) $(ZLIB) $(LDFLAGS)

test:	miniunz minizip
	./minizip test readme.txt
	./miniunz -l test.zip
	mv readme.txt readme.old
	./miniunz test.zip

clean:
	/bin/rm -f *.o *~ minizip miniunz

=== .pc/use-dso-really/contrib/minizip/Makefile ===
CC=cc
CFLAGS+=-O -I../..

UNZ_OBJS = miniunz.o unzip.o ioapi.o ../../libz.a
ZIP_OBJS = minizip.o zip.o   ioapi.o ../../libz.a

.c.o:
	$(CC) -c $(CFLAGS) $*.c

all: miniunz minizip

miniunz:  $(UNZ_OBJS)
	$(CC) $(CFLAGS) -o $@ $(UNZ_OBJS) $(LDFLAGS)

minizip:  $(ZIP_OBJS)
	$(CC) $(CFLAGS) -o $@ $(ZIP_OBJS) $(LDFLAGS)

test:	miniunz minizip
	./minizip test readme.txt
	./miniunz -l test.zip
	mv readme.txt readme.old
	./miniunz test.zip

clean:
	/bin/rm -f *.o *~ minizip miniunz

=== debian/changelog ===
zlib (1:1.2.11.dfsg-2ubuntu9.2+11.0trisquel0) aramo-security; urgency=medium

  * Fetch and build as udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Tue, 01 Nov 2022 15:19:53 +0000

zlib (1:1.2.11.dfsg-2ubuntu9.2) jammy-security; urgency=medium

  * SECURITY UPDATE: heap-based buffer over-read (LP: #1988548)
    - debian/patches/CVE-2022-37434-1.patch: in inflate.c, add an extra
      condition to check if state->head->extra_max is greater than len
      before copying, and move the len assignment to be placed before the
      check.
    - debian/patches/CVE-2022-37434-2.patch: in the previous patch, in
      inflate.c, the place of the len assignment was causing issues so it
      was moved to be placed within the check.
    - CVE-2022-37434

 -- Rodrigo Figueiredo Zaiden <rodrigo.zaiden@canonical.com>  Fri, 14 Oct 2022 18:33:00 -0300

zlib (1:1.2.11.dfsg-2ubuntu9.1) jammy; urgency=medium

  * d/p/410-lp1961427.patch ported from zlib #410, fixing
    compressBound() with hw acceleration. LP: #1961427
    Thanks to Ilya Leoshkevich <iii@linux.ibm.com>.
    In addition a patch is needed for bedtools.

 -- Frank Heimes <frank.heimes@canonical.com>  Thu, 21 Jul 2022 10:30:05 +0100

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: zlib
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 XSBC-Original-Maintainer: Mark Brown <broonie@debian.org>
-Standards-Version: 4.0.0
+Standards-Version: 3.9.8
 Homepage: http://zlib.net/
 Build-Depends: debhelper (>= 8.1.3~), gcc-multilib [amd64 i386 kfreebsd-amd64 mips mipsel powerpc ppc64 s390 sparc s390x mipsn32 mipsn32el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64 mips64el mips64r6 mips64r6el x32] <!nobiarch>, dpkg-dev (>= 1.16.1)
